"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from orq_ai_sdk.types import BaseModel
from orq_ai_sdk.utils import FieldMetadata, PathParamMetadata, RequestMetadata
from typing import Any, Dict, List, Literal, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


CreateDeploymentExperimentType = Literal["deployment_experiment"]


class CreateDeploymentExperimentRequestBodyTypedDict(TypedDict):
    experiment_key: str
    r"""The unique key of the experiment"""
    dataset_id: str
    r"""The id of the dataset to run the experiment on"""
    type: CreateDeploymentExperimentType
    evaluators: NotRequired[List[str]]
    r"""The list of evaluators to use for the experiment. You can apply multiple evaluators to the same experiment. By default we always consider latency and cost as evaluators."""
    path: NotRequired[str]
    r"""The path where the experiment needs to be stored. If not provided, the experiment will be stored in the same path of the dataset used for the experiment."""
    context: NotRequired[Dict[str, Any]]
    r"""Key-value pairs that match your data model and fields declared in your deployment routing configuration. If not provided, the default variant of the deployment will be used to create the experiment"""


class CreateDeploymentExperimentRequestBody(BaseModel):
    experiment_key: str
    r"""The unique key of the experiment"""

    dataset_id: str
    r"""The id of the dataset to run the experiment on"""

    type: CreateDeploymentExperimentType

    evaluators: Optional[List[str]] = None
    r"""The list of evaluators to use for the experiment. You can apply multiple evaluators to the same experiment. By default we always consider latency and cost as evaluators."""

    path: Optional[str] = None
    r"""The path where the experiment needs to be stored. If not provided, the experiment will be stored in the same path of the dataset used for the experiment."""

    context: Optional[Dict[str, Any]] = None
    r"""Key-value pairs that match your data model and fields declared in your deployment routing configuration. If not provided, the default variant of the deployment will be used to create the experiment"""


class CreateDeploymentExperimentRequestTypedDict(TypedDict):
    deployment_key: str
    r"""Deployment Key"""
    request_body: NotRequired[CreateDeploymentExperimentRequestBodyTypedDict]


class CreateDeploymentExperimentRequest(BaseModel):
    deployment_key: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""Deployment Key"""

    request_body: Annotated[
        Optional[CreateDeploymentExperimentRequestBody],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None


class CreateDeploymentExperimentResponseBodyTypedDict(TypedDict):
    r"""Experiment created"""

    url: str
    r"""The url of the experiment run that was just created"""
    experiment_id: str
    r"""The unique identifier of the experiment"""
    experiment_run_id: str
    r"""The unique identifier of the experiment run"""


class CreateDeploymentExperimentResponseBody(BaseModel):
    r"""Experiment created"""

    url: str
    r"""The url of the experiment run that was just created"""

    experiment_id: str
    r"""The unique identifier of the experiment"""

    experiment_run_id: str
    r"""The unique identifier of the experiment run"""
